#!/usr/bin/perl

#↑Perlのパス サーバーのマニュアルをみて確認する

use Encode;

#mailorder ver.7

#設置の仕方、カスタマイズの仕方などはreadme.txtをごらんください。

#************************ 設定項目 *******************************

#-------------- 送料 --------------------

$postage='0';			#送料について 
				#0:計算しない 
				#1:どの商品を何個買っても送料は一定金額 
				#2:全ての商品の送料が同じ 
				#3:商品ごとに違う送料を設定 
				#4:配送方法によって送料を計算

$postage_alt='別途請求';	#$postageを0にして、送料を表示計算しないとき、代わりに文字を表示するときは、''の中に'別途申し請け'などと記入(不要のときは'')
$postage_fix='500';		#$postageを1にしたときは、ここに一定にする送料を記入
$postage_each='500';		#$postageを2にしたときは、ここに一定にする送料を記入

$postage_off='1';		#購入金額が一定以上のときは送料を無料にするときは、1にして、下の$postage_lineで金額指定 $postageの1～4で有効
$postage_line='10000';		#購入金額がこの金額以上なら送料は無料にする
$postage_muryo='1';		#$postage_offを1にしたときに、あと～円の購入で送料が無料に!!と表示するか(0:しない 1:する)


#----------------手数料--------------------

$dai_count_on='0';		#代金引換などのときにその手数料を計算する 1:する0:しない

%dai_count=(
'代金引換'=>'250',
'クロネコペイメント'=>'5%',
);

#$dai_count_onを1にしたときはここに各お支払い方法の料金を
#'お支払い方法'=>'その料金',のように設定
#(%にするときは5%などと設定) 
#購入金額が10000円未満は250円、10000円以上20000円未満は350円、20000以上は450円とするときは、
#"10000:20000_250:350:450"と設定

$dai_off='0';			#購入金額が一定以上のときは手数料を無料にするときは、1にして、下の$dai_lineで金額指定
$dai_line='10000';		#購入金額がこの金額以上なら手数料は無料にする


#-------------------メールの設定------------------------

#確認メールの前後に表示するメッセージを記入します。
#前の文は$email_style1に、後の文は$email_style2に記入

$email_style1=<<'EOM';
ご注文ありがとうございます。
送信されたメールの内容は以下のようになっておりますので
ご確認ください。
EOM

$email_style2=<<'EOM';
どうもありがとうございました。

---------------------------
hoge@ne.jp
http://hoge.ne.jp
---------------------------
EOM



$chk_mailname="あなたかサイトの名前";		#確認メールの送信者に表示する名前
$chk_mailsub='ご注文ありがとうございます。';	#確認メールの件名を設定
$mailsub='注文メール';				#ショップに届く件名

$mailto='xxx@xx.xxx';	#注文のメールを受け取る人(あなた)のメールアドレス
$mailto2='';			#注文メールをもう一つ送るときは''の中に記入
$sama='1';			#$email_style1の文のうえに(送り主)様をつける 1:つける 0:つけない
$sendmail='/usr/sbin/sendmail';	#sendmailのパス サーバーのマニュアルで調べて記入
$checkmail='1';			#確認メールを送るか(0送らない:1:送る)


#------------------- その他 -------------------------------

$dollar='0';		#0:日本円 1:外貨表示
$yen='0';		#円の表示 0:円 1:\
$zei='2';		#税の表示方式(0:旧 1:総額表示(税抜価格を元に税額を出す) 2:総額表示(税込価格を元に税額を出す))
			#1にした場合は、カタログページの<input type="hidden" name="price" value="値段">には
			#税抜きの価格を記入すること。
			#2にした場合は、カタログページの<input type="hidden" name="price" value="値段">には
			#税込みの価格を記入すること。
$tansu='1';		#いわゆる端数処理について(0:個々の商品に税をかけて少数点以下切り捨て 1:小計にまとめて税をかけて小数点以下切り捨て)
			#1にすると余分に税金を払うことになります。
$taxrate='5';		#消費税率(%) 税をかけないときは0にする


#---------------------注文番号-------------------------------

$id='2';			#注文番号の発行 0:しない 1:数字の通し番号(例:00001) 2:年+月+日+日のカウント 3:適当な番号
$digit='5';			#注文番号の桁数($idを1にしたときのみ)
$countlog='log/count.log';	#カウントを記録するファイル
$id_title='1';			#注文番号をメールのタイトルにつけるか 0:つけない 1:つける

#-------------- ファイル -------------------------------

$html_chk='check.html';		#確認画面のスキン
$html_thanks='thanks.html';	#終了画面のHTML
$html_error='error.html';	#エラー画面のHTML
$lockfile='log/lock';		#ロックファイル

#************************ 設定はここまで。************************

unless(-e 'lib/functions.pl'){
	&error("lib/functions.plがありません。");
}
require 'lib/functions.pl';

$maxsize=100000;


if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'}>$maxsize){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}
if($buff){
	&Dec;
}

sub Dec{
my(@pairs,$pair,$value,$name,$forflag,@LINE,$flag,$flag2);
@pairs=split(/&/,$buff);
foreach $pair (@pairs){
	($name,$value)=split(/=/,$pair);
	$value=~tr/+/ /;
	$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value=~s/&/!amp;/g;
	$value=~s/</!lt;/g;
	$value=~s/>/!gt;/g;
	$value=~s/"/!quot;/g;
	$value=~s/'/!#039;/g;
	$name=~tr/+/ /;
	$name=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$name=~s/&//g;
	$name=~s/<//g;
	$name=~s/>//g;
	$name=~s/"//g;
	$name=~s/'//g;
	if($name eq "mode" || $name eq "fukusu" || $name eq "data" || $name eq 'require' || $name eq 'item' || $name eq 'ko'){
		$FORM{$name}=$value;
	}
	elsif($name=~/^for_/){
		$FOR{$name}=$value;
	}
	elsif($name=~/^商品/){
		push @item,$value;
	}
	elsif($name=~/^個数/){
		push @ko,$value;
	}
	else{
		$flag=0;
		foreach(@NAME){
			if($_ eq $name){
				$flag=1;
				last;
			}
		}
		if($flag){
			$flag2=0;
			foreach(@FUKUSU){
				if($_ eq $name){
					$flag2=1;
				}
			}
			if(!$flag2){
				push @FUKUSU,$name;
			}
			if($DATA{$name}){
				$DATA{$name}.='_!a_'.$value;
			}
		}
		else{
			push @NAME,$name;
			$DATA{$name}=$value;
		}
	}
}

}


if($FORM{'mode'} eq "send"){
	&Send;
}
elsif($FORM{'mode'} eq "check"){
	&Check;
}

sub Check{
my($skinline,$head,$dummy,$tr,$footer,@require,$email,$err,
$l,$flag,$tr_d,$fflag,$v,$value,$input,$showline,$fukusu,$data,@keys,@tmp,$itemline,$koline,
$middle,$g_line_ref,$dai_charge_c,$dai_name,$total_c,$tax_c,$subtotal_c,
$postage_all_c,$total,$subtotal,$tax,$postage_all,
$dai_charge,$pay,$a_total,$ar,$deliver,$vol_all,$weight_all,$i,@all,$name,$price,
$pt,$weight,$line,$pack,$goods,$tax_all,$dum

);

if(!@item){
	$err.="商品が選択されていません。<br>";
}

$i=0;
@all=();
foreach(@item){
	if($_){
		($name,$price,$pt,$weight,$pack)=split(/:/,$_);
		$line="$name,$price,$ko[$i],$pt,$weight,$pack";
		push @all,$line;
	}
	$i++;
}


@require=split(/,/,$FORM{'require'});
$email=$DATA{$FOR{'for_email'}};
$ar=$DATA{'お届け先都道府県'} || $DATA{'都道府県'};
$pay=$DATA{'お支払い方法'};
$deliver=$DATA{'配送方法'};

$err="";

foreach $l(@require){
	$flag=0;
	if(!$DATA{$l}){
		$flag=1;

	}
	if($flag){
		$err.="$lが入力されていません。<br>";
	}
}

if($email){
	if($email !~ /^([a-zA-Z0-9\.\-\/_]{1,})@([a-zA-Z0-9\.\-\/_]{1,})\.([a-zA-Z0-9\.\-\/_]{1,})$/){
		$err.="メールアドレスが正しくありません。全角で入力されていないか等確認してください。";
	}
}



if($err){
	&error($err);
}


unless(open(HTML, $html_chk)){
	&error("$html_chkが開けません。ファイルを確認してください。");
}
$skinline=join('',<HTML>);
close(HTML);

($head,$dummy) = split(/<!--goodsstart-->/, $skinline);
if($head eq ""){
	&error("$html_chkに&lt;!--goodsstart--&gt;が書かれていません。");
}
($goods,$dummy) = split(/<!--goodsend-->/, $dummy);
if($goods eq ""){
	&error("$html_chkに&lt;!--goodsend--&gt;が書かれていません。");
}

($middle,$dummy)=split(/<!--start-->/,$dummy);
if($middle eq ""){
	&error("$html_chkに<!--start-->が書かれていません。");
}
($tr,$footer)=split(/<!--end-->/,$dummy);
if($tr eq ""){
	&error("$html_chkに<!--end-->が書かれていません。");
}


$subtotal=0;
$a_total=0;
$postage_all=0;
$tax_all=0;
$tax=0;
$total=0;
$weight_all=0;


($subtotal,$a_total,$tax_all,$postage_all,$weight_all,$vol_all,$dum,$g_line_ref)=&GoodsCal($goods,\@all);
($tax,$total)=&Tax($subtotal,$tax_all);
if($postage != 4){
	($total,$postage_all)=&PostageCal($total,$subtotal,$postage_all,$a_total,$cool_count);
}
else{
	if($ar eq ""){
		&error('都道府県がありません。');
	}
	if($deliver eq ""){
		&error('配送方法がありません。');
	}
	($total,$postage_all)=&PostageCal2($total,$subtotal,$weight_all,$vol_all,$deliver,$ar,$cool_count,$a_total);

}
$dai_charge=0;
if($dai_count_on){
	if($pay eq ""){
		&error('お支払い方法がありません。');
	}
	($dai_charge,$total,$dai_name)=&Dai($pay,$total,$subtotal);
	$dai_charge_c=&Comma($dai_charge);
}
else{
	$middle =~ s/<!--tesu-->.*?<!--\/tesu-->//is;

}
$postage_all_c=&Comma($postage_all);
$tax_c=&Comma($tax);
$subtotal+=$tax if($zei==1);
$subtotal_c=&Comma($subtotal);
$total_c=&Comma($total);

if(!$postage){
	if($postage_alt){
		$middle=~ s/<!--postage-->/$postage_alt/;
	}
	else{
		$middle =~ s/<!--postage-->/$postage_all_c/;
	}
}
else{
	$middle=~ s/<!--postage-->/$postage_all_c/;
}


$middle =~ s/<!--subtotal-->/$subtotal_c/;
$middle =~ s/<!--tax-->/$tax_c/;
$middle =~ s/<!--total-->/$total_c/;
$middle =~ s/<!--dai-->/$dai_name/;
$middle =~ s/<!--charge-->/$dai_charge_c/;

foreach $l(@NAME){
	$tr_d=$tr;
	$fflag=0;
	foreach $v(@FUKUSU){
		if($l eq $v){
			$fflag=1;
		}
	}
	$value=$DATA{$l};
	$value=~s/\x0D\x0A/\n/g;
	$value=~s/\x0D/\n/g;
	$value=~s/\x0A/\n/g;
	$input.=qq(<input type="hidden" name="$l" value="$value">\n);

	if($fflag){
		@tmp=split(/_!a_/,$value);
		$value=join(' ',@tmp);
	}

	$value=~s/\n/<br>/g;
	$value=~s/!amp;/&amp;/g;
	$value=~s/!lt;/&lt;/g;
	$value=~s/!gt;/&gt;/g;
	$value=~s/!quot;/&quot;/g;
	$value=~s/!#039;/&#039;/g;
	$tr_d =~ s/<!--name-->/$l/;
	$tr_d =~ s/<!--value-->/$value/;
	$showline.=$tr_d;

}

$fukusu=join('_!_',@FUKUSU);
$data=join('_!_',@NAME);
$itemline=join('_!_',@item);
$koline=join(':',@ko);

$input.="<input type=\"hidden\" name=\"fukusu\" value=\"$fukusu\">\n";
$input.="<input type=\"hidden\" name=\"data\" value=\"$data\">\n";
$input.="<input type=\"hidden\" name=\"item\" value=\"$itemline\">\n";
$input.="<input type=\"hidden\" name=\"ko\" value=\"$koline\">\n";
@keys=keys %FOR;

foreach(@keys){
	$input.="<input type=\"hidden\" name=\"$_\" value=\"$FOR{$_}\">\n";
}

$footer =~ s/<!--input-->/$input/;


print "Content-type: text/html\n\n";
print $head;
print ${$g_line_ref};
print $middle;
print $showline;
print $footer;
exit;


}
sub End{
unless(open(HTML, $html_thanks)){
	&error("$html_thanksが開けません。ファイルを確認してください。");
}

print "Content-type: text/html\n\n";
while(<HTML>){
print $_;
}
close HTML;
exit;
}


sub Send{
my($email,$name,$title,@na,@fukusu,$l,$v,$value,$fflag,
$chk_mailbody,$mailbody,@tmp,$host,@item,$mailbody_goods,$postage_all_c,
$tax_c,$subtotal_c,$goods_all_ref,$date,$odrID,$total_c,$subtotal,
$postage_all,$dai_charge_c,$total,$pay,$dai_name,$ar,$deliver,$vol_all,
$tax,$dai_charge,$a_total,$weight_all,@all,$tax_all,$pack,$pt,$i,
$price,$line,@ko,$weight,
$sec,$min,$hour,$mday,$mon,$year,$wday,@waweek,$y_f,
$count,$tday,$day,$na
);


$email=$DATA{$FOR{'for_email'}};
$name=$DATA{$FOR{'for_name'}};
if($mailsub){
	$title=$mailsub;
}
elsif($DATA{$FOR{'for_title'}}){
	$title=$DATA{$FOR{'for_title'}};
}
else{
	$title='タイトル未設定';
}

if($email eq ""){
	&error("メールアドレスがありません。");
}
if(length($email) >100){
	&error("メールアドレスが不適切です。");
}
if($email=~/,/){
	&error("メールアドレスが不適切です。");
}
if($email=~/\n/){
	&error("メールアドレスが不適切です。");
}
if($email !~ /^([a-zA-Z0-9\.\-\/_]{1,})@([a-zA-Z0-9\.\-\/_]{1,})\.([a-zA-Z0-9\.\-\/_]{1,})$/){
	&error("メールアドレスが正しくありません。全角で入力されていないか等確認してください。");
}
if($title=~/\n/){
	&error("タイトルが不適切です。");
}
if($name=~/\n/){
	&error("名前が不適切です。");
}

@item=split(/_!_/,$FORM{'item'});
@ko=split(/:/,$FORM{'ko'});

if(!@item){
	&error("商品が選択されていません。");
}

if(scalar(@item) != scalar(@ko)){
	&error("商品と個数の個数が一致していません。");
}


($sec,$min,$hour,$mday,$mon,$year,$wday)=localtime(time);
$mon++;
$min=sprintf("%02d",$min);
$year=$year+1900;
$mon=sprintf("%02d",$mon);
$day=$mday;
@waweek=('日','月','火','水','木','金','土');
$date="$year年$mon月$mday日($waweek[$wday]) $hour時$min分";
$mday=sprintf("%02d",$mday);
$y_f=substr($year,2,2);

if($id == 1){
	&filelock;
	unless(open(FILE,"$countlog")){
		&error("$countlogが開けません。");
	}
	$line=<FILE>;
	close (FILE);
	($count)=split(/,/,$line);
	if($count eq ""){
		$count=0;
	}
	$count++;
	unless(open(FILE,">$countlog")){
		&error("$countlogに書き込みできません。");
	}
	print FILE "$count";
	close FILE;
	$odrID=sprintf("%0${digit}d",$count);
	if($lockflag==1){
		close LOCK;
	}

}
elsif($id == 2){
	&filelock;
	unless(open(FILE,"$countlog")){
		&error("$countlogが開けません。");
	}
	$line=<FILE>;
	close (FILE);
	($count,$tday)=split(/,/,$line);
	if($count eq ""){
		$count=0;
	}
	if($tday == $day){
		$count++;
	}
	else{
		$tday=$day;
		$count=1;
	}
	$line="$count,$tday";
	unless(open(FILE,">$countlog")){
		&error("$countlogに書き込みできません。");
	}
	print FILE $line;
	close FILE;
	$odrID=$y_f.$mon.$mday.$count;
	if($lockflag==1){
		close LOCK;
	}
}
elsif($id == 3){
	$hour=sprintf("%02d",$hour);
	$sec=sprintf("%02d",$sec);
	$odrID="$y_f$mon$mday$hour$min$sec$$";
}

if($id == 0){
	$odrID="";
}

if($id_title){
	$title.=" $odrID";
}

$i=0;
@all=();
foreach(@item){
	if($_){
		($na,$price,$pt,$weight,$pack)=split(/:/,$_);
		$line="$na,$price,$ko[$i],$pt,$weight,$pack";
		push @all,$line;
	}
	$i++;
}


$subtotal=0;
$a_total=0;
$postage_all=0;
$tax_all=0;
$tax=0;
$total=0;
$weight_all=0;


$ar=$DATA{'お届け先都道府県'} || $DATA{'都道府県'};
$pay=$DATA{'お支払い方法'};
$deliver=$DATA{'配送方法'};

($subtotal,$a_total,$tax_all,$postage_all,$weight_all,$vol_all,$goods_all_ref)=&GoodsCal("",\@all);
($tax,$total)=&Tax($subtotal,$tax_all);
if($postage != 4){
	($total,$postage_all)=&PostageCal($total,$subtotal,$postage_all,$a_total,$cool_count);
}
else{
	if($ar eq ""){
		&error('都道府県がありません。');
	}
	if($deliver eq ""){
		&error('配送方法がありません。');
	}
	($total,$postage_all)=&PostageCal2($total,$subtotal,$weight_all,$vol_all,$deliver,$ar,$cool_count,$a_total);
}
$dai_charge=0;
if($dai_count_on){
	if($pay eq ""){
		&error('お支払い方法がありません。');
	}
	($dai_charge,$total,$dai_name)=&Dai($pay,$total,$subtotal);
	$dai_charge_c=&Comma($dai_charge);
}

$postage_all_c=&Comma($postage_all);
$tax_c=&Comma($tax);
$subtotal+=$tax if($zei==1);
$subtotal_c=&Comma($subtotal);
$total_c=&Comma($total);


$mailbody_goods=<<EOM;
============================================================
ご注文番号  : $odrID
ご注文日時  : $date
============================================================

■ご注文品
------------------------------------------------------------
${$goods_all_ref}

小計        :  $subtotal_c
(うち消費税):  $tax_c
送料        :  $postage_all_c
EOM

if($dai_count_on){
$mailbody_goods.=<<EOM;
手数料      :  $dai_charge_c
EOM
}

$mailbody_goods.=<<EOM;
----------------------------
合計        :  $total_c
EOM



@na=split(/_!_/,$FORM{'data'});
@fukusu=split(/_!_/,$FORM{'fukusu'});

foreach $l(@na){
	$fflag=0;
	foreach $v(@fukusu){
		if($l eq $v){
			$fflag=1;
		}
	}
	$value=$DATA{$l};

	$value=~s/\x0D\x0A/\n/g;
	$value=~s/\x0D/\n/g;
	$value=~s/\x0A/\n/g;

	$value=~s/!amp;/&/g;
	$value=~s/!quot;/"/g;
	$value=~s/!#039;/'/g;
	$value=~s/!lt;/</g;
	$value=~s/!gt;/>/g;

	if($fflag){
		@tmp=split(/_!a_/,$value);
		$value=join(' ',@tmp);
	}
	$mailbody.=$l.": ".$value."\n";
}

if($sama){
	$email_style1="$name 様\n\n".$email_style1;
}

$mailbody=$mailbody_goods.$mailbody;

$chk_mailbody=$email_style1.$mailbody.$email_style2;

$host=&GetHost;
$mailbody.="\n";
$mailbody.="IP address: $ENV{'REMOTE_ADDR'}\n";
$mailbody.="Host      : $host\n";
$mailbody.="User Agent: $ENV{'HTTP_USER_AGENT'}\n";

&S_Mail($mailto,$email,$name,$title,$mailbody);
if($checkmail){
	&S_Mail($email,$mailto,$chk_mailname,$chk_mailsub,$chk_mailbody);
}
if($mailto2){
	&S_Mail($mailto2,$email,$name,$title,$mailbody);
}

&End;
}

sub GetHost{
my($addr,$ho);
$ho=$ENV{'REMOTE_HOST'};
$addr=$ENV{'REMOTE_ADDR'};
if($ho eq "" || $ho eq $addr){
	$ho=gethostbyaddr(pack("C4", split(/\./, $addr)),2) || $addr;
}

return $ho;
}


sub S_Mail{
my($to,$from,$fromname,$sub,$mailbody);
$to=$_[0];
$from=$_[1];
$fromname=$_[2];
$sub=$_[3];
$mailbody=$_[4];


if($fromname){
	$fromname=encode('jis',decode('utf8',$fromname));
	$fromname=&mail64encode($fromname);
	$fromname="$fromname <$from>";
}
else{
	$fromname=$from;
}
if($sub){
	$sub=encode('jis',decode('utf8',$sub));
	$sub=&mail64encode($sub);
}

$mailbody=encode('jis',decode('utf8',$mailbody),Encode::FB_XMLCREF);

$mailbody=~s/\e\(B&#xff5e;\e\$B/\e\$B\x21\x41/g;
$mailbody=~s/\e\(B&#xff5e;/\e\$B\x21\x41\e\(B/g;
$mailbody=~s/&#xff5e;\e\$B/\e\$B\x21\x41/g;
$mailbody=~s/&#xff5e;/\e\$B\x21\x41\e\(B/g;

$mailbody=~s/\e\(B&#xff0d;\e\$B/\e\$B\x21\x3e/g;
$mailbody=~s/\e\(B&#xff0d;/\e\$B\x21\x3e\e\(B/g;
$mailbody=~s/&#xff0d;\e\$B/\e\$B\x21\x3e/g;
$mailbody=~s/&#xff0d;/\e\$B\x21\x3e\e\(B/g;


if(!open(MAIL, "| $sendmail -t -i")){
	&error("メール送信できません。sendmailのパス等を確認してください。");
}
print MAIL "To: $to\n";
print MAIL "From: $fromname\n";
print MAIL "Subject: $sub\n";
print MAIL "MIME-Version: 1.0\n";
print MAIL "Content-Type: text/plain\; charset=\"ISO-2022-JP\"\n";
print MAIL "Content-Transfer-Encoding: 7bit\n\n";
print MAIL "$mailbody\n";
close(MAIL);
}



sub mail64encode {
my($tmp_bun) = $_[0];
$tmp_bun = &base64encode($tmp_bun);
return("=?ISO-2022-JP?B?${tmp_bun}?=");
}

sub base64encode {
my($base) = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
my($x, $y, $z, $i);
$x = unpack("B*", $_[0]);
for ($i = 0; $y = substr($x, $i, 6); $i += 6) {
$z .= substr($base, ord(pack("B*", "00" . $y)), 1);
if (length($y) == 2){
$z .= "==";
}elsif (length($y) == 4){
$z .= "=";
}
}
return($z);
}


sub error{
my($err,$skinline);

$err=$_[0];
unless(open(HTML,$html_error)){
	&dmyerror("$_[0]$html_errorが開けません。ファイル名を確認してください。");
}
$skinline = join('',<HTML>);
close(HTML);

$skinline=~s/<!--error-->/$err/;

print "Content-type: text/html\n\n";
print $skinline;
exit;
}

sub dmyerror{

print "Content-type: text/html\n\n";
print "<html><body>$_[0]</body></html>";
exit;
}




exit;